import { U32Range } from "../u32-range";
import { u32, i32 } from "replayable-random/dist/types/util/number";
export declare type Node = ValuedNode | undefined;
export declare class ValuedNode {
    static leaf(iRange: U32Range): ValuedNode;
    readonly left: Node;
    value: U32Range;
    readonly right: Node;
    rank: u32;
    constructor(l: Node, v: U32Range, r: Node);
    setLeft(l: Node): void;
    setRight(r: Node): void;
    update(): void;
    updated(): ValuedNode;
    balanceFactor(): i32;
    isBalanced(): boolean;
    isRightUnbalanced(): this is this & {
        right: ValuedNode;
    };
    isRightOriented(): this is this & {
        right: ValuedNode;
    };
    isLeftOriented(): this is this & {
        left: ValuedNode;
    };
    isSlighlyLeftUnbalanced(): this is this & {
        left: ValuedNode;
    };
    rotateLeft(this: this & {
        right: ValuedNode;
    }): ValuedNode;
    rotateRight(this: this & {
        left: ValuedNode;
    }): ValuedNode;
    balance(): ValuedNode;
    min(): U32Range;
    max(): U32Range;
    predecessor(): U32Range | undefined;
    successor(): U32Range | undefined;
    removeMin(): Node;
    removeMax(): Node;
    /** @Override */
    removePredecessor(): void;
    /** @Override */
    removeSuccessor(): void;
    mergeLeft(): void;
    mergeRight(): void;
    insertableLeft(iRange: U32Range): U32Range[];
    insertableRight(iRange: U32Range): U32Range[];
    insertable(iRange: U32Range): U32Range[];
    insertLeft(iRange: U32Range): U32Range[];
    insertRight(iRange: U32Range): U32Range[];
    insert(iBlock: U32Range): U32Range[];
}
